Index: /trunk/src/org/apollo/gui/ExpandedTrackPopup.java
===================================================================
--- /trunk/src/org/apollo/gui/ExpandedTrackPopup.java	(revision 1101)
+++ /trunk/src/org/apollo/gui/ExpandedTrackPopup.java	(revision 1102)
@@ -2,24 +2,16 @@
 
 import java.awt.BorderLayout;
-import java.awt.Color;
 import java.awt.Dimension;
 import java.awt.Event;
 import java.awt.Font;
-import java.awt.Graphics;
+import java.awt.Graphics2D;
 import java.awt.GridBagConstraints;
 import java.awt.GridBagLayout;
 import java.awt.Insets;
 import java.awt.Point;
-import java.awt.Rectangle;
 import java.awt.event.ActionEvent;
 import java.awt.event.ActionListener;
-import java.awt.event.KeyEvent;
-import java.awt.event.KeyListener;
-import java.awt.event.MouseEvent;
-import java.awt.event.MouseListener;
-import java.awt.event.MouseMotionListener;
 
 import javax.sound.sampled.LineUnavailableException;
-import javax.swing.Icon;
 import javax.swing.JButton;
 import javax.swing.JPanel;
@@ -45,13 +37,19 @@
 import org.apollo.util.AudioMath;
 import org.apollo.widgets.TrackWidgetCommons;
+import org.expeditee.core.Colour;
+import org.expeditee.core.Image;
+import org.expeditee.core.bounds.AxisAlignedBoxBounds;
+import org.expeditee.gio.EcosystemManager;
+import org.expeditee.gio.input.InputEvent;
+import org.expeditee.gio.input.InputEventListener;
+import org.expeditee.gio.swing.SwingConversions;
+import org.expeditee.gio.swing.SwingMiscManager;
 import org.expeditee.gui.Browser;
-import org.expeditee.gui.FrameGraphics;
+import org.expeditee.gui.DisplayController;
 import org.expeditee.gui.Popup;
-import org.expeditee.gui.PopupManager;
-
-public class ExpandedTrackPopup extends Popup implements ActionListener, Observer {
-	
-	private static final long serialVersionUID = 1L;
-	
+import org.expeditee.gui.PopupManager.ExpandShrinkAnimator;
+
+public class ExpandedTrackPopup extends Popup implements ActionListener, Observer
+{
 	/** The observed subject. Can never be null */
 	private SampledTrackModel trackModel; // immutable
@@ -61,4 +59,5 @@
 	private TrackMixSubject trackMix; // immutable
 
+	private JPanel panel;
 	private JButton playPauseButton;
 	private JButton stopButton;
@@ -106,7 +105,10 @@
 			String trackSourceFrameName,
 			int frameStart,
-			int frameLength) {
-		super(new BorderLayout());
+			int frameLength)
+	{
+		super(new ExpandShrinkAnimator());
 		super.setConsumeBackClick(true);
+		
+		panel = new JPanel(new BorderLayout());
 		
 		if (trackModel == null) throw new NullPointerException("trackModel");
@@ -121,5 +123,5 @@
 		playPauseButton = new JButton();
 		playPauseButton.addActionListener(this);
-		playPauseButton.setIcon(IconRepository.getIcon("play.png"));
+		SwingMiscManager.setJButtonIcon(playPauseButton, IconRepository.getIcon("play.png"));
 		playPauseButton.setPreferredSize(new Dimension(BUTTON_SIZE, BUTTON_SIZE));
 		playPauseButton.setToolTipText("Play selection / Pause");
@@ -128,5 +130,5 @@
 		stopButton.setEnabled(false);
 		stopButton.addActionListener(this);
-		stopButton.setIcon(IconRepository.getIcon("stop.png"));
+		SwingMiscManager.setJButtonIcon(stopButton, IconRepository.getIcon("stop.png"));
 		stopButton.setPreferredSize(new Dimension(BUTTON_SIZE, BUTTON_SIZE));
 		stopButton.setToolTipText("Stop playback");
@@ -134,5 +136,5 @@
 		rewindButton = new JButton();
 		rewindButton.addActionListener(this);
-		rewindButton.setIcon(IconRepository.getIcon("rewind.png"));
+		SwingMiscManager.setJButtonIcon(rewindButton, IconRepository.getIcon("rewind.png"));
 		rewindButton.setPreferredSize(new Dimension(BUTTON_SIZE, BUTTON_SIZE));
 		rewindButton.setToolTipText("Rewind to start");
@@ -140,5 +142,5 @@
 		// Icon changes
 		muteButton = new JToggleButton();
-		muteButton.setSelectedIcon(IconRepository.getIcon("volmute.png"));
+		SwingMiscManager.setJButtonIcon(muteButton, IconRepository.getIcon("volmute.png"));
 		muteButton.setPreferredSize(new Dimension(BUTTON_SIZE, BUTTON_SIZE));
 		muteButton.setToolTipText("Toggle mute");
@@ -153,6 +155,6 @@
 		
 		soloButton = new JToggleButton();
-		soloButton.setIcon(IconRepository.getIcon("solo.png"));
-		soloButton.setSelectedIcon(IconRepository.getIcon("soloon.png"));
+		SwingMiscManager.setJButtonIcon(soloButton, IconRepository.getIcon("solo.png"));
+		SwingMiscManager.setJButtonSelectedIcon(soloButton, IconRepository.getIcon("soloon.png"));
 		soloButton.setPreferredSize(new Dimension(BUTTON_SIZE, BUTTON_SIZE));
 		soloButton.setToolTipText("Toggle solo");
@@ -170,5 +172,5 @@
 		closeButton = new JButton();
 		closeButton.addActionListener(this);
-		closeButton.setIcon(IconRepository.getIcon("close.png"));
+		SwingMiscManager.setJButtonIcon(closeButton, IconRepository.getIcon("close.png"));
 		closeButton.setPreferredSize(new Dimension(BUTTON_SIZE, BUTTON_SIZE));
 		closeButton.setToolTipText("Close");
@@ -216,86 +218,9 @@
 		nameLabelParent = new JPanel();
 		
-		nameLabelParent.addMouseListener(new MouseListener() {
-
-			public void mouseClicked(MouseEvent e) {
-				if (nameLabel != null) {
-					if (nameLabel.onMouseClicked(e)) {
-						e.consume();
-						return;
-					}
-				}
-			}
-
-			public void mouseEntered(MouseEvent e) {
-			}
-
-			public void mouseExited(MouseEvent e) {
-			}
-
-			public void mousePressed(MouseEvent e) {
-				if (nameLabel != null) {
-					if (nameLabel.onMousePressed(e)) {
-						e.consume();
-					}
-				}
-			}
-
-			public void mouseReleased(MouseEvent e) {
-				if (nameLabel != null) {
-					if (nameLabel.onMouseReleased(e)) {
-						e.consume();
-					}
-				}
-			}
-		
-		});
-		
-		nameLabelParent.addMouseMotionListener(new MouseMotionListener() {
-
-			public void mouseDragged(MouseEvent e) {
-				if (nameLabel != null) {
-					if (nameLabel.onMouseDragged(e)) {
-						e.consume();
-					}
-				}
-			}
-
-			public void mouseMoved(MouseEvent e) {
-				if (nameLabel != null) {
-					nameLabel.onMouseMoved(e, nameLabelParent);
-				}
-			}
-
-		});
-		
-		nameLabelParent.addKeyListener(new KeyListener() {
-
-			public void keyPressed(KeyEvent e) {
-				if (nameLabel != null) {
-					if (nameLabel.onKeyPressed(e, nameLabelParent)) {
-						e.consume();
-					}
-				}
-			}
-
-			public void keyReleased(KeyEvent e) {
-				if (nameLabel != null) {
-					if (nameLabel.onKeyReleased(e, nameLabelParent)) {
-						e.consume();
-					}
-				}
-
-			}
-
-			public void keyTyped(KeyEvent e) {
-			}
-			
-		});
-		
-		nameLabel = new EmulatedTextItem(nameLabelParent, new Point(10, 25));
-		nameLabel.setFontStyle(Font.BOLD);
+		nameLabel = new EmulatedTextItem(trackModel.getName(), SwingConversions.fromSwingPoint(new Point(10, 25)));
+		nameLabel.setFontStyle(SwingConversions.fromSwingFontStyle(Font.BOLD));
 		nameLabel.setFontSize(16);
-		nameLabel.setBackgroundColor(Color.WHITE);	
-		nameLabel.setText(trackModel.getName()); 
+		nameLabel.setBackgroundColor(Colour.WHITE);
+		nameLabel.gainFocus();
 
 		nameLabel.addTextChangeListener(new TextChangeListener() { //  a little bit loopy!
@@ -373,6 +298,6 @@
 		toolBarPanel.add(closeButton, c);
 		
-		this.add(toolBarPanel, BorderLayout.NORTH);
-		this.add(splitPane, BorderLayout.CENTER);
+		panel.add(toolBarPanel, BorderLayout.NORTH);
+		panel.add(splitPane, BorderLayout.CENTER);
 		
 		// Observe track model
@@ -430,13 +355,8 @@
 		ExpandedTrackManager.getInstance().receiveExpandedTrackPopup(xtp);
 	}
-
+	
 	@Override
-	public void onShowing() {
-
-	}
-	
-	@Override
-	public void onShow() {
-		
+	public void onShow()
+	{
 		if (splitPane.getHeight() < 140) {
 			splitPane.setDividerLocation(splitPane.getHeight() - 30);
@@ -456,10 +376,11 @@
 		// Invalidate full frame for shading
 		if (Browser._theBrowser != null) {
-			FrameGraphics.refresh(false);
+			DisplayController.requestRefresh(false);
 		}
 	}
 
 	@Override
-	public void onHide() {
+	public void onHide()
+	{
 		ExpandedTrackManager.getInstance().expandedTrackPopupHidden(this);
 		releaseMemory(); // get rid of buffer etc..
@@ -470,22 +391,22 @@
 		// Invalidate full frame for shading
 		if (Browser._theBrowser != null) {
-			FrameGraphics.refresh(false);
+			DisplayController.requestRefresh(false);
 		}
 	}
 	
-	
-
-
 	@Override
-	public void paint(Graphics g) {
-		super.paint(g);
-		
-		g.translate(-getX(), -getY());
-		nameLabel.paint(g);
-		g.translate(getX(), getY());
-		
-	}
-
-	public void actionPerformed(ActionEvent e) {
+	public void paintInternal()
+	{
+		Graphics2D g = SwingMiscManager.getIfUsingSwingGraphicsManager().getCurrentSurface();
+		
+		panel.paint(g);
+		
+		g.translate(-getFullBounds().getMinX(), -getFullBounds().getMinY());
+		nameLabel.paint();
+		g.translate(getFullBounds().getMinX(), getFullBounds().getMinY());
+	}
+
+	public void actionPerformed(ActionEvent e)
+	{
 		if (trackModel == null) return;
 		
@@ -587,8 +508,5 @@
 			// If there are more expanded tracks showing then the ExpandedTrackManager
 			// will automatically re-layout the remaing views.
-			PopupManager.getInstance().hidePopup(this, 
-					PopupManager.getInstance().new ExpandShrinkAnimator(
-					new Rectangle(0, getY(), 1, getHeight()),
-							Color.LIGHT_GRAY));
+			hide();
 			
 		}
@@ -660,5 +578,5 @@
 			stopButton.setEnabled(true);
 			rewindButton.setEnabled(false);
-			playPauseButton.setIcon(IconRepository.getIcon("pause.png"));
+			SwingMiscManager.setJButtonIcon(playPauseButton, IconRepository.getIcon("pause.png"));
 
 			setBorderThickness(TrackWidgetCommons.PLAYING_TRACK_EDGE_THICKNESS);
@@ -670,5 +588,5 @@
 			rewindButton.setEnabled(true);
 			stopButton.setEnabled(false);
-			playPauseButton.setIcon(IconRepository.getIcon("play.png"));
+			SwingMiscManager.setJButtonIcon(playPauseButton, IconRepository.getIcon("play.png"));
 			
 			// Note:
@@ -810,7 +728,7 @@
 		
 		// Get border color currently used
-		Color oldC = getBorderColor();
-		
-		Color newC = TrackWidgetCommons.getBorderColor(
+		Colour oldC = getBorderColor();
+		
+		Colour newC = TrackWidgetCommons.getBorderColor(
 				SoundDesk.getInstance().isSolo(trackMix.getChannelID()), 
 				trackMix.isMuted());
@@ -828,5 +746,5 @@
 	private void updateButtonGUI() {
 		
-		Icon newIcon = null;
+		Image newIcon = null;
 		if (volumeSlider.getValue() <= 25) 
 				newIcon = IconRepository.getIcon("vol25.png");
@@ -838,5 +756,5 @@
 				newIcon = IconRepository.getIcon("vol100.png");
 		
-		muteButton.setIcon(newIcon);
+		SwingMiscManager.setJButtonIcon(muteButton, newIcon);
 	}
 
@@ -846,8 +764,20 @@
 	 * 		Never null.
 	 */
-	public String getTrackSourceFrameName() {
+	public String getTrackSourceFrameName()
+	{
 		return trackSourceFrameName;
 	}
 	
+	public void setBounds(int x, int y, int width, int height)
+	{
+		panel.setBounds(x, y, width, height);
+	}
+
+	@Override
+	public AxisAlignedBoxBounds getFullBounds()
+	{
+		return SwingConversions.fromSwingRectangle(panel.getBounds());
+	}
+	
 	
 }
Index: /trunk/src/org/apollo/gui/FastAlphaEffect.java
===================================================================
--- /trunk/src/org/apollo/gui/FastAlphaEffect.java	(revision 1101)
+++ /trunk/src/org/apollo/gui/FastAlphaEffect.java	(revision 1102)
@@ -60,10 +60,12 @@
 			int x, int y, 
 			int width, int height,
-			int rgb) {
+			int rgb)
+	{
 		
-		if (raster == null)
+		if (raster == null) {
 			throw new NullPointerException("raster");
-		else if (colorModel == null)
+		} else if (colorModel == null) {
 			throw new NullPointerException("raster");
+		}
 		
 		int endcol = x + width;
Index: /trunk/src/org/apollo/gui/FrameLayoutDaemon.java
===================================================================
--- /trunk/src/org/apollo/gui/FrameLayoutDaemon.java	(revision 1101)
+++ /trunk/src/org/apollo/gui/FrameLayoutDaemon.java	(revision 1102)
@@ -1,15 +1,8 @@
 package org.apollo.gui;
 
-import java.awt.Point;
-import java.awt.event.ComponentEvent;
-import java.awt.event.ComponentListener;
-import java.awt.event.MouseEvent;
 import java.io.File;
-import java.lang.reflect.InvocationTargetException;
 import java.util.Collection;
 import java.util.HashMap;
 import java.util.Map;
-
-import javax.swing.SwingUtilities;
 
 import org.apollo.audio.ApolloSubjectChangedEvent;
@@ -30,14 +23,16 @@
 import org.apollo.widgets.LinkedTrack;
 import org.apollo.widgets.SampledTrack;
-import org.expeditee.gui.Browser;
-import org.expeditee.gui.DisplayIO;
-import org.expeditee.gui.DisplayIOObserver;
+import org.expeditee.core.Point;
+import org.expeditee.gio.EcosystemManager;
+import org.expeditee.gio.InputManager.WindowEventListener;
+import org.expeditee.gio.InputManager.WindowEventType;
+import org.expeditee.gio.gesture.StandardGestureActions;
+import org.expeditee.gui.DisplayController;
+import org.expeditee.gui.DisplayObserver;
 import org.expeditee.gui.Frame;
-import org.expeditee.gui.FrameMouseActions;
 import org.expeditee.gui.FreeItems;
-import org.expeditee.gui.MouseEventRouter;
 import org.expeditee.items.Item;
 import org.expeditee.items.ItemUtils;
-import org.expeditee.items.widgets.InteractiveWidget;
+import org.expeditee.items.widgets.Widget;
 import org.expeditee.items.widgets.WidgetCorner;
 import org.expeditee.items.widgets.WidgetEdge;
@@ -46,5 +41,5 @@
  * A daemon that lays out overdubbed frames.
  * 
- * It is a singletone. Also it is a subject which raises empty events whenever
+ * It is a singleton. Also it is a subject which raises empty events whenever
  * a new timeline is created.
  * 
@@ -52,5 +47,5 @@
  *
  */
-public class FrameLayoutDaemon extends AbstractSubject implements Observer, DisplayIOObserver {
+public class FrameLayoutDaemon extends AbstractSubject implements Observer, DisplayObserver {
 	
 	/** The frame that should not be layout out at any point in time. */
@@ -98,30 +93,12 @@
 		daemon.start();
 		AudioStructureModel.getInstance().addObserver(this);
-		DisplayIO.addDisplayIOObserver(this);
-		
-		// Listen for resize events
-		SwingUtilities.invokeLater(new Runnable() {
-			public void run() {
-
-				// Keep expanded view centered to the browser window
-				if (Browser._theBrowser != null) {
-					Browser._theBrowser.addComponentListener(new ComponentListener() {
-
-						public void componentHidden(ComponentEvent e) {
-						}
-
-						public void componentMoved(ComponentEvent e) {
-						}
-
-						public void componentResized(ComponentEvent e) {
-							forceRecheck();
-						}
-
-						public void componentShown(ComponentEvent e) {
-						}
-						
-					});
-				}
-				
+		DisplayController.addDisplayObserver(this);
+		
+		EcosystemManager.getInputManager().addWindowEventListener(new WindowEventListener()
+		{
+			@Override
+			public void onWindowEvent(WindowEventType type)
+			{
+				if (type == WindowEventType.WINDOW_RESIZED) forceRecheck();
 			}
 		});
@@ -321,5 +298,5 @@
 				// Note that accessing expeditee model in another thread --
 				// Being real careful not to do anything unsafe
-				Frame currentFrame = DisplayIO.getCurrentFrame();
+				Frame currentFrame = DisplayController.getCurrentFrame();
 				if (currentFrame == null) continue;
 
@@ -340,9 +317,7 @@
 				
 				try {
-					SwingUtilities.invokeAndWait(trackFormatter);
-				} catch (InterruptedException e) {
+					EcosystemManager.getMiscManager().runOnGIOThread(trackFormatter);
+				} catch (Throwable e) {
 					e.printStackTrace();
-				} catch (InvocationTargetException e) {
-					e.printStackTrace();
 				}
 				
@@ -359,6 +334,6 @@
 				assert(toFormat != null);
 				
-				// To late?
-				if (toFormat != DisplayIO.getCurrentFrame()) return;
+				// Too late?
+				if (toFormat != DisplayController.getCurrentFrame()) return;
 				
 				boolean supressSpatialLayout = suspendedFrame == toFormat;
@@ -370,7 +345,7 @@
 				boolean hasRunningTime = false; // A flag set to true if there is actual audio to [lay
 				
-				Map<InteractiveWidget, AbstractTrackGraphNode> widgetsToFormat = new HashMap<InteractiveWidget, AbstractTrackGraphNode>();
-	
-				for (InteractiveWidget iw : toFormat.getInteractiveWidgets()) {
+				Map<Widget, AbstractTrackGraphNode> widgetsToFormat = new HashMap<Widget, AbstractTrackGraphNode>();
+	
+				for (Widget iw : toFormat.getInteractiveWidgets()) {
 					
 					AbstractTrackGraphNode abinf = null;
@@ -429,7 +404,5 @@
 				
 				// Anything to format?
-				if (!hasRunningTime || 
-						widgetsToFormat.isEmpty() || 
-						longestEndTime == firstInitiationTime) {
+				if (!hasRunningTime || widgetsToFormat.isEmpty() || longestEndTime == firstInitiationTime) {
 					
 					// NOTE: longestEndTime == firstInitiationTime indicates linked tracks 
@@ -450,5 +423,5 @@
 					// Ensure that left most pixel is at a reasonable position
 					if (!supressSpatialLayout && (initiationXPixel < 0 ||
-							(initiationXPixel > Browser._theBrowser.getWidth() && Browser._theBrowser.getWidth() > leftMargin))) {
+							(initiationXPixel > DisplayController.getFramePaintArea().getWidth() && DisplayController.getFramePaintArea().getWidth() > leftMargin))) {
 						initiationXPixel = leftMargin;
 					} else if (!supressSpatialLayout && initiationXPixel > LAYOUT_MAX_INITIATION_PIXEL) {
@@ -459,5 +432,5 @@
 						timelineWidth = rightMostPixel - initiationXPixel;
 					} else {
-						timelineWidth = Browser._theBrowser.getWidth() - initiationXPixel - rightMargin;
+						timelineWidth = DisplayController.getFramePaintArea().getWidth() - initiationXPixel - rightMargin;
 					}
 					
@@ -483,5 +456,5 @@
 				if (!supressSpatialLayout) {
 					
-					for (InteractiveWidget iw : widgetsToFormat.keySet()) {
+					for (Widget iw : widgetsToFormat.keySet()) {
 						
 						AbstractTrackGraphNode atgi = widgetsToFormat.get(iw);
@@ -545,5 +518,5 @@
 			
 				Item i = FreeItems.getItemAttachedToCursor();
-				InteractiveWidget freespaceTrackToFormat = null;
+				Widget freespaceTrackToFormat = null;
 				if (i != null && i instanceof WidgetEdge) {
 					freespaceTrackToFormat = ((WidgetEdge)i).getWidgetSource();
@@ -573,6 +546,7 @@
 					if (width > 0) {
 						
-						if (width > (Browser._theBrowser.getWidth() - (2 * FREE_SPACE_MARGINS)))
-							width = Browser._theBrowser.getWidth() - (2 * FREE_SPACE_MARGINS);
+						if (width > (DisplayController.getFramePaintArea().getWidth() - (2 * FREE_SPACE_MARGINS))) {
+							width = DisplayController.getFramePaintArea().getWidth() - (2 * FREE_SPACE_MARGINS);
+						}
 
 						freespaceTrackToFormat.setSize(
@@ -582,16 +556,12 @@
 						
 						// Keep the floating track on the cursor
-						MouseEvent me = MouseEventRouter.getCurrentMouseEvent();
-						Point containerPoint = SwingUtilities.convertPoint(me.getComponent(), me.getPoint(), Browser._theBrowser.getContentPane());
-						
+						Point containerPoint = EcosystemManager.getInputManager().getCursorPosition();
+						
+						// If due to resize the track is not longer over the cursor then just center it.
 						if (!ItemUtils.expandRectangle(freespaceTrackToFormat.getBounds(), 20).contains(containerPoint)) {
-							// If due to resize the track is not longer over the cursor then just center it.
 							int offsetX = width / 2; 
 							int offsetY = freespaceTrackToFormat.getHeight() / 2;
-							freespaceTrackToFormat.setPosition(
-									containerPoint.x - offsetX, 
-									containerPoint.y - offsetY);
-							FrameMouseActions.resetOffset();
-		
+							freespaceTrackToFormat.setPosition(containerPoint.x - offsetX, containerPoint.y - offsetY);
+							StandardGestureActions.resetOffset();
 						}
 						
@@ -756,5 +726,5 @@
 
 		// Look for all track widgets
-		for (InteractiveWidget iw : frame.getInteractiveWidgets()) {
+		for (Widget iw : frame.getInteractiveWidgets()) {
 			
 			if (iw instanceof SampledTrack) {
@@ -928,5 +898,5 @@
 	public static long inferCurrentTotalMSTime() {
 		
-		Frame currentFrame = DisplayIO.getCurrentFrame();
+		Frame currentFrame = DisplayController.getCurrentFrame();
 		String currentFrameName = (currentFrame != null) ? currentFrame.getName() : null;
 		
Index: /trunk/src/org/apollo/gui/FramePlaybackBarRenderer.java
===================================================================
--- /trunk/src/org/apollo/gui/FramePlaybackBarRenderer.java	(revision 1101)
+++ /trunk/src/org/apollo/gui/FramePlaybackBarRenderer.java	(revision 1102)
@@ -1,13 +1,6 @@
 package org.apollo.gui;
 
-import java.awt.BasicStroke;
-import java.awt.Color;
-import java.awt.Graphics2D;
-import java.awt.Rectangle;
-import java.awt.Stroke;
 import java.util.LinkedList;
 import java.util.List;
-
-import javax.swing.SwingUtilities;
 
 import org.apollo.audio.ApolloPlaybackMixer;
@@ -23,8 +16,12 @@
 import org.apollo.util.AudioMath;
 import org.apollo.widgets.FramePlayer;
+import org.expeditee.core.Colour;
+import org.expeditee.core.Stroke;
+import org.expeditee.core.bounds.AxisAlignedBoxBounds;
+import org.expeditee.gio.EcosystemManager;
+import org.expeditee.gio.GraphicsManager;
 import org.expeditee.gui.Browser;
-import org.expeditee.gui.DisplayIO;
+import org.expeditee.gui.DisplayController;
 import org.expeditee.gui.Frame;
-import org.expeditee.gui.FrameGraphics;
 
 /**
@@ -50,6 +47,6 @@
 	
 	private static final int BAR_STROKE_THICKNESS = 2;
-	private static final Stroke BAR_STROKE = new BasicStroke(BAR_STROKE_THICKNESS);
-	private static final Color BAR_COLOR = Color.DARK_GRAY;
+	private static final Stroke BAR_STROKE = new Stroke(BAR_STROKE_THICKNESS);
+	private static final Colour BAR_COLOR = Colour.DARK_GREY;
 	
 	private static FramePlaybackBarRenderer instance = new FramePlaybackBarRenderer();
@@ -121,5 +118,5 @@
 			}
 			
-			FrameGraphics.refresh(true);
+			DisplayController.requestRefresh(true);
 			
 			
@@ -132,5 +129,5 @@
 			currentMSPosition = -1;
 			pixelPositions.clear();
-			FrameGraphics.refresh(true);
+			DisplayController.requestRefresh(true);
 			
 			break;
@@ -140,29 +137,30 @@
 	}
 	
-	private void invalidate() {
+	private void invalidate()
+	{
 		if (Browser._theBrowser == null) return;
 		
-		int height = Browser._theBrowser.getHeight();
+		int height = EcosystemManager.getGraphicsManager().getWindowSize().getHeight();
 		
 		for (Integer n : pixelPositions) {
-			FrameGraphics.invalidateArea(new Rectangle(n - 1, 0, BAR_STROKE_THICKNESS + 2, height));
-		}
-	}
-	
-	public void paint(Graphics2D g) {
+			DisplayController.invalidateArea(new AxisAlignedBoxBounds(n - 1, 0, BAR_STROKE_THICKNESS + 2, height));
+		}
+	}
+	
+	public void paint()
+	{
 		if (Browser._theBrowser == null) return;
 		
-		Frame currentFrame = DisplayIO.getCurrentFrame();
+		Frame currentFrame = DisplayController.getCurrentFrame();
 		
 		if (currentFrame == null || currentFrame.getName() == null || pixelPositionsParent == null ||
 				!currentFrame.getName().equals(pixelPositionsParent)) return;
 		
-		int height = Browser._theBrowser.getHeight();
-		
-		g.setColor(BAR_COLOR);
-		g.setStroke(BAR_STROKE);
+		int height = EcosystemManager.getGraphicsManager().getWindowSize().getHeight();
+		
+		GraphicsManager gm = EcosystemManager.getGraphicsManager();
 		
 		for (Integer n : pixelPositions) {
-			g.drawLine(n, 0, n, height);
+			gm.drawLine(n, 0, n, height, BAR_COLOR, BAR_STROKE);
 		}
 	}
@@ -193,5 +191,5 @@
 		// Notes: the clock will queue a refresh for the frame after this
 		// event proccesses ... 
-		SwingUtilities.invokeLater(updator);
+		EcosystemManager.getMiscManager().runOnGIOThread(updator);
 	}
 	
@@ -201,10 +199,11 @@
 	 * @author Brook Novak
 	 */
-	private class PlaybackFrameBarUpdator implements Runnable {
+	private class PlaybackFrameBarUpdator implements Runnable
+	{
 		public void run() {
 			
 			if (currentMSPosition == -1 || currentTimeline == null) return;
 			
-			Frame currentFrame = DisplayIO.getCurrentFrame();
+			Frame currentFrame = DisplayController.getCurrentFrame();
 			
 			if (currentFrame == null || currentFrame.getName() == null) return;
